#define CHARS_PER_COL 32
#define CHARS_PER_BLOCK 8
#define LPCHAR B00011    // Left Paddle Character
#define RPCHAR B11000   // Right Paddle Character
#define BCHAR B00001    // Ball Character

int bounce = 0; char direction = 'L';
int ball_row = 2, ball_column = 10;
int paddleL_row = 0, paddleR_row = 0;
int paddleL_up = 0, paddleL_down = 0, paddleR_up = 0, paddleR_down = 0;

byte paddleLeft[CHARS_PER_COL] = {  0, 0, 0, 0, 0, 0, 0, 0,
                  0, 0, 0, 0, LPCHAR, LPCHAR, LPCHAR, LPCHAR,
                  LPCHAR, LPCHAR, LPCHAR, LPCHAR, 0, 0, 0, 0,
                  0, 0, 0, 0, 0, 0, 0, 0 };

byte paddleRight[CHARS_PER_COL] = { 0, 0, 0, 0, 0, 0, 0, 0,
                  0, 0, 0, 0, RPCHAR, RPCHAR, RPCHAR, RPCHAR,
                  RPCHAR, RPCHAR, RPCHAR, RPCHAR, 0, 0, 0, 0,
                  0, 0, 0, 0, 0, 0, 0, 0};

byte ball_vect[CHARS_PER_COL] = { 0, 0, 0, 0, 0, 0, 0, 0,
                  0, 0, 0, 0, 0, 0, 0, BCHAR,
                  0, 0, 0, 0, 0, 0, 0, 0,
                  0, 0, 0, 0, 0, 0, 0, 0};

byte paddleLeft_1[CHARS_PER_BLOCK];
byte paddleLeft_2[CHARS_PER_BLOCK];
byte paddleRight_1[CHARS_PER_BLOCK];
byte paddleRight_2[CHARS_PER_BLOCK];
byte ball[CHARS_PER_BLOCK];


void paddleUp(byte paddle[CHARS_PER_COL], int initial_val) {
  int temp, i, maxPos = CHARS_PER_COL - 1;

  if (paddle[0] != initial_val) {
    temp = paddle[0];
    for (i = 0; i < maxPos; i++)
      paddle[i] = paddle[i + 1];
    paddle[i] = temp;
  }
}

void paddleDown(byte paddle[CHARS_PER_COL], int initial_val) {
  int temp, i, maxPos = CHARS_PER_COL - 1;

  if (paddle[maxPos] != initial_val) {
    temp = paddle[maxPos];
    for (i = maxPos; i > 0; i--)
      paddle[i] = paddle[i - 1];
    paddle[i] = temp;
  }
}

void ballRight() {
  for (int i = 0; i < CHARS_PER_COL; i++) {
    if (ball_vect[i] != 0) {
      if (ball_vect[i] == B00001) {
        ball_vect[i] = B10000;
        continue;
      }
      ball_vect[i] = ball_vect[i] >> 1;
    }
  }
}

void ballLeft() {
  for (int i = 0; i < CHARS_PER_COL; i++) {
    if (ball_vect[i] != 0) {
      if (ball_vect[i] == B10000) {
        ball_vect[i] = B00001;
        continue;
      }
      ball_vect[i] = ball_vect[i] << 1;
    }
  }
}

void ballDown(char directionBall) {
  int temp, i, maxPos = CHARS_PER_COL - 1;

  if (ball_vect[maxPos] == 0) {
    temp = ball_vect[maxPos];
    for (i = maxPos; i > 0; i--)
      ball_vect[i] = ball_vect[i - 1];
    ball_vect[i] = temp;
    
    if (directionBall == 'L') 
      ballLeft();
    else 
      ballRight();
  }
  else
    bounce = 1;
}

void ballUp(char directionBall) {
  int temp, i, maxPos = CHARS_PER_COL - 1;

  if (ball_vect[0] == 0) {
    temp = ball_vect[0];
    for (i = 0; i < maxPos; i++)
      ball_vect[i] = ball_vect[i + 1];
    ball_vect[i] = temp;

    if (directionBall == 'L') 
      ballLeft();
    else 
      ballRight();
  }
  else
    bounce = 0;
}

// Mutare cursoare pe verticala 
void movePaddles() {
  // Mutare paddle din stanga
  if (paddleL_up == 1) {
    paddleUp(paddleLeft, LPCHAR);
    delay(50);
  }
  if (paddleL_down == 1) {
    paddleDown(paddleLeft, LPCHAR);
    delay(50);
  }

  // Mutare paddle din dreapta
  if (paddleR_up == 1) {
    paddleUp(paddleRight, RPCHAR);
    delay(50);
  }
  if (paddleR_down == 1) {
    paddleDown(paddleRight, RPCHAR);
    delay(50);
  }
}

// Mutare minge
void moveBall() {
  // Mingea se misca la stanga
  if (direction == 'L') {
    for (int i = 0; i < CHARS_PER_COL; i++)
      // Mingea ajunge la marginea din stanga a blocului
      // Se trece la blocul anterior din stanga
      if (ball_vect[i] == B10000) 
        ball_column -= 1;

    if (bounce == 0)
      ballDown('L');
    else
      ballUp('L');
  }

  // Mingea se misca la dreapta
  if (direction == 'R') {
    for (int i = 0; i < CHARS_PER_COL; i++)
      // Mingea ajunge la marginea din dreapta a blocului
      // Se trece la blocul urmator din dreapta
      if (ball_vect[i] == B00001)
        ball_column += 1;

    if (bounce == 0)
      ballDown('R');
    else
      ballUp('R');
  }
}
